#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>
#include "ddu4.h"

#include "eth_hook_4.h"
#define PAGE_SIZE 4096

static int fd_schar;

static char *data;

static char *buf_start;
static unsigned long int buf_pnt;
static unsigned long int buf_end;
static unsigned long int buf_eend;
static unsigned long int buf_pnt_kern;

static char *ring_start;
static unsigned long int ring_size;
static unsigned long int ring_pnt;
static int short ring_loop;
static int short ring_loop_kern;
static int short ring_loop_kern2;
int short timeout;  // timeout waiting for event
int short packets; // # of packets in event
int short pmissing;    // packets are  missing at beginning
int short pmissing_prev; // packets may be missing at end
int short end_event;   // end of event seen
int short overwrite;   // overwrite 

static char *tail_start;

/* ioctl's for schar. */
#include "schar.h"

int init_ddu4(void)
{     
       fd_schar = open("/dev/schar4", O_RDWR);
        /* complain if the open failed */
        if (fd_schar == -1) {
	  printf("open failure so quit");exit(1);
                return 1;
        } 
        buf_start = (char *)mmap(NULL,BIGPHYS_PAGES_4*PAGE_SIZE,PROT_READ,MAP_PRIVATE,fd_schar,0);
	if (buf_start==MAP_FAILED) {
			perror("mmaptest user ");
			return 1;
	}; 
        buf_end=(BIGPHYS_PAGES_4-RING_PAGES_4)*PAGE_SIZE-TAILPOS-MAXPACKET_4;
        buf_eend=(BIGPHYS_PAGES_4-RING_PAGES_4)*PAGE_SIZE-TAILPOS-MAXEVENT_4;
        ring_start=buf_start+(BIGPHYS_PAGES_4-RING_PAGES_4)*PAGE_SIZE;
        ring_size=(RING_PAGES_4*PAGE_SIZE-RING_ENTRY_LENGTH-TAILMEM)/RING_ENTRY_LENGTH;
        tail_start=buf_start+BIGPHYS_PAGES_4*PAGE_SIZE-TAILPOS;
        buf_pnt=0;
        ring_pnt=0;
        ring_loop=0;
        pmissing=0;
        pmissing_prev=0; 

	// reset_ddu();
return 0;
}

int read_ddu4(char **buf,void *data2)
{
int j;
int length,len; 
long int iloop;
  packets=0;
  len=0;
  timeout=0;
  overwrite=0;
  pmissing=0;
  pmissing_prev=0;
  iloop=0;
MAINLOOP:     
	  buf_pnt_kern=*(unsigned long int *)(buf_start+BIGPHYS_PAGES_4*PAGE_SIZE-TAILPOS);
          if(iloop>100000){timeout=1;goto MAINEND;}
          if(buf_pnt==buf_pnt_kern){for(j=0;j<5000;j++);iloop++;goto MAINLOOP;}
          iloop=0;

          ring_loop_kern= *(unsigned short int *)(ring_start+ring_pnt*RING_ENTRY_LENGTH);
          pmissing=ring_loop_kern&0x8000;
          end_event=ring_loop_kern&0x4000;
          ring_loop_kern=ring_loop_kern&0x3fff;
	  length=*(unsigned short int *)(ring_start+ring_pnt*RING_ENTRY_LENGTH+4);
	  //      printf(" packets %d %04x %d \n",packets,end_event,length);
          ring_loop_kern2=*(unsigned short int *)ring_start;
          ring_loop_kern2=0x3fff&ring_loop_kern2; 
          if((ring_loop_kern2!=ring_loop)&&(buf_pnt<=buf_pnt_kern)){
            overwrite=1;
	    printf(" BUFFER OVERWRITE \n");goto MAINEND;
          }
          if(ring_loop_kern!=ring_loop){
            overwrite=1;
            printf(" RING LOOP OVERWRITE \n");goto MAINEND;
          }
          
          if(packets==0){
              data=buf_start+buf_pnt;
          }
          len=len+length; 
                     
          if(pmissing!=0&packets!=0){
            len=len-length;
            pmissing_prev=1;
            goto MAINEND;
          }

          buf_pnt=buf_pnt+length;
          ring_pnt=ring_pnt+1;
	  if(((end_event==0x4000)&&(buf_pnt>buf_eend))||(buf_pnt > buf_end)||(ring_pnt>=ring_size)){ 
             ring_pnt=0;
             ring_loop=ring_loop+1;
             buf_pnt=0;
             //printf(" RING BUFFER IS ROLLING OVER \n");
          }
          packets=packets+1;
          if(len>MAXEVENT_4)goto MAINEND;
          if(pmissing!=0)goto MAINEND;
          if(end_event==0x4000)goto MAINEND;
          goto MAINLOOP;
 MAINEND:
    data=data-4;
    *buf=(char *)data;
    if(len==0)len=6;
    return len;
  }


int reset_ddu4(void)
{ 
  if(ioctl(fd_schar,SCHAR_RESET)==-1){
    printf(" error in SCHAR_RESET \n");
  }
        buf_pnt=0;
        ring_pnt=0;
        ring_loop=0;
        pmissing=0;
  return 0;
}

int enableblock_ddu4(void)
{
  return 0;
}

int disableblock_ddu4(void)
{
  return 0;
}

void printstats_ddu4()
{
}

int endblockread_ddu4()
{
  return 0;
}


void close_ddu4(void)
{
	munmap((void *)buf_start,BIGPHYS_PAGES_4*PAGE_SIZE);
        close(fd_schar);
        return;
}
